######################################################################
library(nnet)
bartModelMatrix=function(X) { ###write expand X with all dummies
require(nnet)
p=ncol(X)
Xnum = NULL
Xfac = NULL
for(i in 1:p) { # for each xi add to Xnum if numeric else add dummies to Xfac
   #cat(i,"\n")
   xnm = names(X)[i]
   print(xnm)
   if(is.factor(X[[i]])) {
      Xtemp = class.ind(X[[i]])
      #colnames(Xtemp) = paste(xnm,1:ncol(Xtemp),sep="")
      colnames(Xtemp) = paste(xnm,".",levels(X[[i]]),sep="")
      Xfac = cbind(Xfac,Xtemp)
   } else {
      Xnum=cbind(Xnum,X[[i]])
      colnames(Xnum)[ncol(Xnum)]=xnm
   }
}
return(cbind(Xnum,Xfac))
}
######################################################################
if(1) {cat("###set parameters\n")
####################
if(0) {###Alcohol
   pnm = "Alcohol"
   facind = c(
   3,
   5:8,
   15
   )
}
####################
if(1) {###Fishery
   pnm="Fishery"
   facind = c(1,8,9)
}
}
######################################################################
if(1) {cat("###read\n")

fnm = paste0("./",pnm,"/01",".bld")
trMat = as.matrix(read.table(fnm))

fnm = paste0("./",pnm,"/01",".tst")
teMat = as.matrix(read.table(fnm))

aMat = rbind(trMat,teMat)
ddf = as.data.frame(aMat)
p=ncol(ddf)
vnms = c(paste0("x",1:(p-1)),"y")
names(ddf) = vnms
for(i in facind) ddf[[i]]=as.factor(ddf[[i]])

fnm= paste0(pnm,".csv")
write.csv(ddf,file=fnm,row.names=FALSE)

}
######################################################################
if(1) {cat("make bart matrices\n")
xdf = ddf[,1:(p-1)]
xmatBart = bartModelMatrix(xdf)
ddfB = data.frame(xmatBart,y=aMat[,p])

fnm= paste0(pnm,"-Bart.csv")
write.csv(ddfB,file=fnm,row.names=FALSE)
}




